      subroutine rmp_neighbor(np,nc,nebtt,nebbb,nebll,nebrr,ibc)
c
c  define your neighbor with total processors of np and
c  number of colume nc. The number sequence is from 1 in
c  x direction, then y direction up to np.
c  If ibc=0 and your neighbour is not in the full domain, 
c  the return value is -1.
c  If ibc=1 the cyclic boundary condition applied.
c
c  neighbour map 
c                       |           |
c                nebtl  |   nebtt   |   nebtr  
c                       |           |
c               --------+-----------+---------
c                       |           |
c                       |           |
c                       |           |
c                nebll  |    you    |   nebrr
c                       |           |
c                       |           |
c                       |           |
c               --------+-----------+---------
c                       |           |
c                nebbl  |   nebbb   |   nebbr
c                       |           |
c
c author: Hann-Ming Henry Juang
c email : henry.juang@noaa.gov
c
c
c
      dimension nebtt(np),nebbb(np),nebll(np),nebrr(np)
c
      do n=1,np
        ntt=n+nc
        nbb=n-nc
        nll=n-1
        nrr=n+1
        if( ibc.eq.1 ) then
          if( ntt.gt.np ) ntt=ntt-np
          if( nbb.lt.1 )  nbb=nbb+np
          if( mod(nll,nc).eq.0 ) nll=nll+nc
          if( mod(nrr,nc).eq.1 ) nrr=nrr-nc
          if( nc.eq.1 ) then
            nrr=n
            nll=n
          endif
        else
          if( ntt.gt.np ) ntt=0
          if( nbb.lt.1 )  nbb=0
          if( mod(nll,nc).eq.0 ) nll=0
          if( mod(nrr,nc).eq.1 ) nrr=0
          if( nc.eq.1 ) then
            nrr=0
            nll=0
          endif
        endif
        nebtt(n)=ntt-1
        nebbb(n)=nbb-1
        nebll(n)=nll-1
        nebrr(n)=nrr-1
      enddo
c
      return
      end
