      subroutine rmp_updatehalo(a,nxp,myp,ntotal,lb)
#include <define.h>
c
c update the halo regions from neighbour PEs
c
c
c author: Hann-Ming Henry Juang
c email : henry.juang@noaa.gov
c
#ifdef MPE
#include <rmp_mpif.h>
#include <rmp_rank.h>
#include <rmp_index.h>
c
      dimension a(nxp,myp,ntotal)
      real(_mpi_real_),allocatable::sendtt(:),recvtt(:)
      real(_mpi_real_),allocatable::sendbb(:),recvbb(:)
      real(_mpi_real_),allocatable::sendll(:),recvll(:)
      real(_mpi_real_),allocatable::sendrr(:),recvrr(:)
#ifdef PRIME
      real(_mpi_real_)            ::prime(ntotal)
#endif
#ifdef CHECKSTATUS
      integer status(MPI_STATUS_SIZE)
#endif
c
#ifdef COUNT_TIME
      call timer(its)
#endif
      allocate(sendtt(nxp*lb*ntotal))
      allocate(sendbb(nxp*lb*ntotal))
      allocate(sendll(myp*lb*ntotal))
      allocate(sendrr(myp*lb*ntotal))
      sendtt(:)=-88.
      sendbb(:)=-88.
      sendll(:)=-88.
      sendrr(:)=-88.
c
      allocate(recvtt(nxp*lb*ntotal))
      allocate(recvbb(nxp*lb*ntotal))
      allocate(recvll(myp*lb*ntotal))
      allocate(recvrr(myp*lb*ntotal))
      recvtt(:)=-99.
      recvbb(:)=-99.
      recvll(:)=-99.
      recvrr(:)=-99.
c
c send and receive interactively with wait
c
      ntagtt=1
      ntagbb=2
      ntagll=3
      ntagrr=4
      nebtt=mynebtt(mynum)
      nebbb=mynebbb(mynum)
      nebll=mynebll(mynum)
      nebrr=mynebrr(mynum)


c -------------- top and bottom (partial) ----------
c tt

#if defined PRIME && defined PREFETCH
      if( nebtt.ne.-1 ) then
        do k=1,ntotal
!           print*,myrank,': prefetch nebll ',loc(a(lb+1,1,k))
           call mm_prefetch(a(lb+1,myjlen(mynum)-lb*2+1,k),1)
           prime(k)=a(lb+1,myjlen(mynum)-lb*2+1,k)
        enddo
      endif
      if( nebll.ne.-1 ) then
        do k=1,ntotal
!           print*,myrank,': prefetch nebrr ',loc(a(myilen(mynum)-lb*2+1,1,k))
           call mm_prefetch(a(lb+1,lb+1,k),1)
           prime(k)=a(lb+1,lb+1,k)
        enddo
      endif
#endif

      if( nebtt.ne.-1 ) then
        lentt=ntotal*lb*(nxp-2*lb)
        call mpi_irecv(recvtt,lentt,mpi_real,nebtt,ntagbb,mpi_comm_world,irecvtt,ierr)
!#if defined PRIME && defined PREFETCH
!        do k=1,ntotal
!!           print*,myrank,': prefetch nebtt ',loc(a(lb+1,myjlen(mynum)-lb*2+1,k))
!           call mm_prefetch(a(lb+1,myjlen(mynum)-lb*2+1,k),1)
!           prime(k)=a(lb+1,myjlen(mynum)-lb*2+1,k)
!        enddo
!#endif
        mk=0
#ifdef TIMERS
        wstart = MPI_Wtime()
#endif
        do k=1,ntotal
#ifdef VERSION2D
          do j=1,1
#else
          do j=myjlen(mynum)-lb*2+1,myjlen(mynum)-lb
#endif
            do i=lb+1,myilen(mynum)-lb
               mk=mk+1
               sendtt(mk)=a(i,j,k)
             enddo
           enddo
        enddo
#ifdef TIMERS
        wstop = MPI_Wtime()
!        print*,myrank,': sending to ',nebtt,sendtt(1),sendtt(2),sendtt(3)
        print *,myrank,': time packing sendtt',(wstop-wstart)*1.e6,' us'
#endif
      else
        lentt=0
        nebtt=MPI_PROC_NULL
        call mpi_irecv(recvtt,lentt,mpi_real,nebtt,ntagbb,mpi_comm_world,irecvtt,ierr)
      endif
c send
      call mpi_isend(sendtt,lentt,mpi_real,
     1                nebtt,ntagtt,mpi_comm_world,isendtt,ierr)
c recv
!      call mpi_irecv(recvtt,lentt,mpi_real,
!     1                nebtt,ntagbb,mpi_comm_world,irecvtt,ierr)
c bb
      if( nebbb.ne.-1 ) then
        lenbb=ntotal*lb*(nxp-2*lb)
        call mpi_irecv(recvbb,lenbb,mpi_real,nebbb,ntagtt,mpi_comm_world,irecvbb,ierr)
!if defined PRIME && defined PREFETCH
!        do k=1,ntotal
!           print*,myrank,': prefetch nebbb ',loc(a(lb+1,lb+1,k))
!           call mm_prefetch(a(lb+1,lb+1,k),1)
!           prime(k)=a(lb+1,lb+1,k)
!        enddo
!#endif
        mk=0
#ifdef TIMERS
        wstart = MPI_Wtime()
#endif
        do k=1,ntotal
#ifdef VERSION2D
          do j=1,1
#else
          do j=lb+1,lb*2
#endif
            do i=lb+1,myilen(mynum)-lb
               mk=mk+1
               sendbb(mk)=a(i,j,k)
             enddo
           enddo
         enddo
#ifdef TIMERS
        wstop = MPI_Wtime()
!        print*,myrank,': sending to ',nebbb,sendbb(1),sendbb(2),sendbb(3)
        print *,myrank,': time packing sendbb',(wstop-wstart)*1.e6,' us'
#endif
      else
        lenbb=0
        nebbb=MPI_PROC_NULL
        call mpi_irecv(recvbb,lenbb,mpi_real,nebbb,ntagtt,mpi_comm_world,irecvbb,ierr)
      endif
c send
      call mpi_isend(sendbb,lenbb,mpi_real,
     1                nebbb,ntagbb,mpi_comm_world,isendbb,ierr)
c recv
!      call mpi_irecv(recvbb,lenbb,mpi_real,
!     1                nebbb,ntagtt,mpi_comm_world,irecvbb,ierr)

! And now we wait for the recv to finish then unpack the buffer
! -------------------------------------------------------------

#if defined PRIME && defined PREFETCH
      if( nebll.ne.-1 ) then
        do k=1,ntotal
!           print*,myrank,': prefetch nebll ',loc(a(lb+1,1,k))
           call mm_prefetch(a(lb+1,1,k),1)
           prime(k)=a(lb+1,1,k)
        enddo
      endif
      if( nebrr.ne.-1 ) then
        do k=1,ntotal
!           print*,myrank,': prefetch nebrr ',loc(a(myilen(mynum)-lb*2+1,1,k))
           call mm_prefetch(a(myilen(mynum)-lb*2+1,1,k),1)
           prime(k)=a(myilen(mynum)-lb*2+1,1,k)
        enddo
      endif
#endif

c tt
#ifdef CHECKSTATUS
      call mpi_wait(irecvtt, status, ierr)
      write(6,"(a,i4,a,i8,i4,i4,i4,i4,i4)"),'Rank ',myrank,': Status from wait on irecvtt ',status, ierr
#else
      call mpi_wait(irecvtt, MPI_STATUS_IGNORE, ierr)
#endif
      if( nebtt.ne.MPI_PROC_NULL ) then
#if defined PREFETCH
!        call mm_prefetch(a(lb+1,myjlen(mynum)-lb+1,:),1)
#endif
        mk=0
#ifdef TIMERS
        wstart = MPI_Wtime()
#endif
        do k=1,ntotal
#ifdef VERSION2D
          do j=1,1
#else
          do j=myjlen(mynum)-lb+1,myjlen(mynum)
#endif
            do i=lb+1,myilen(mynum)-lb
               mk=mk+1
#ifdef CHECKRECV
               if(recvtt(mk) .ne. dble(nebtt)) then
          write(6,"(a,i4,a,i4,i4,i4,a,i4,i4,i4)"),'Rank ',myrank,' recvtt .ne. nebtt at ',i,j,k,' mk=',mk,int(recvtt(mk)),nebtt
                  stop
               endif
#endif
               a(i,j,k)=recvtt(mk)
             enddo
           enddo
         enddo
#ifdef TIMERS
        wstop = MPI_Wtime()
        print *,myrank,': time unpacking recvtt',(wstop-wstart)*1.e6,' us'
#endif
      endif
c bb
#ifdef CHECKSTATUS
      call mpi_wait(irecvbb, status, ierr)
      write(6,"(a,i4,a,i8,i4,i4,i4,i4,i4)"),'Rank ',myrank,': Status from wait on irecvbb ',status, ierr
#else
      call mpi_wait(irecvbb, MPI_STATUS_IGNORE, ierr)
#endif
      if( nebbb.ne.MPI_PROC_NULL ) then
#if defined PREFETCH
!        call mm_prefetch(a(lb+1,1,:),1)
#endif
        mk=0
#ifdef TIMERS
        wstart = MPI_Wtime()
#endif
        do k=1,ntotal
#ifdef VERSION2D
          do j=1,1
#else
          do j=1,lb
#endif
            do i=lb+1,myilen(mynum)-lb
               mk=mk+1
#ifdef CHECKRECV
               if(recvbb(mk) .ne. dble(nebbb)) then
          write(6,"(a,i4,a,i4,i4,i4,a,i4,i4,i4)"),'Rank ',myrank,' recvbb .ne. nebbb at ',i,j,k,' mk=',mk,int(recvbb(mk)),nebbb
                  stop
               endif
#endif
               a(i,j,k)=recvbb(mk)
             enddo
           enddo
         enddo
#ifdef TIMERS
        wstop = MPI_Wtime()
        print *,myrank,': time unpacking recvbb',(wstop-wstart)*1.e6,' us'
#endif
      endif

c
c ----------------- left and right (full) ----------------
c ll
      if( nebll.ne.-1 ) then
        lenll=ntotal*myp*lb
        call mpi_irecv(recvll,lenll,mpi_real,nebll,ntagrr,mpi_comm_world,irecvll,ierr)
!        do k=1,ntotal
!!           print*,myrank,': prefetch nebll ',loc(a(lb+1,1,k))
!           call mm_prefetch(a(lb+1,1,k),1)
!           prime(k)=a(lb+1,1,k)
!        enddo
        mk=0
#ifdef TIMERS
        wstart = MPI_Wtime()
#endif
        do k=1,ntotal
#ifdef VERSION2D
          do j=1,1
#else
          do j=1,myjlen(mynum)
#endif
            do i=lb+1,lb*2
               mk=mk+1
               sendll(mk)=a(i,j,k)
             enddo
           enddo
         enddo
#ifdef TIMERS
        wstop = MPI_Wtime()
!        print*,myrank,': sending to ',nebll,sendll(1),sendll(2),sendll(3),sendll(4),sendll(5)
        print *,myrank,': time packing sendll',(wstop-wstart)*1.e6,' us'
#endif
      else
        lenll=0
        nebll=MPI_PROC_NULL
        call mpi_irecv(recvll,lenll,mpi_real,nebll,ntagrr,mpi_comm_world,irecvll,ierr)
      endif
c send
      call mpi_isend(sendll,lenll,mpi_real,
     1                nebll,ntagll,mpi_comm_world,isendll,ierr)
c recv
!      call mpi_irecv(recvll,lenll,mpi_real,
!     1                nebll,ntagrr,mpi_comm_world,irecvll,ierr)
c rr
      if( nebrr.ne.-1 ) then
        lenrr=ntotal*myp*lb
        call mpi_irecv(recvrr,lenrr,mpi_real,nebrr,ntagll,mpi_comm_world,irecvrr,ierr)
!        do k=1,ntotal
!!           print*,myrank,': prefetch nebrr ',loc(a(myilen(mynum)-lb*2+1,1,k))
!           call mm_prefetch(a(myilen(mynum)-lb*2+1,1,k),1)
!           prime(k)=a(myilen(mynum)-lb*2+1,1,k)
!        enddo
        mk=0
#ifdef TIMERS
        wstart = MPI_Wtime()
#endif
        do k=1,ntotal
#ifdef VERSION2D
          do j=1,1
#else
          do j=1,myjlen(mynum)
#endif
            do i=myilen(mynum)-lb*2+1,myilen(mynum)-lb
               mk=mk+1
               sendrr(mk)=a(i,j,k)
             enddo
           enddo
         enddo
#ifdef TIMERS
        wstop = MPI_Wtime()
!        print*,myrank,': sending to ',nebrr,sendrr(1),sendrr(2),sendrr(3),sendrr(4),sendrr(5)
        print *,myrank,': time packing sendrr',(wstop-wstart)*1.e6,' us'
#endif
      else
        lenrr=0
        nebrr=MPI_PROC_NULL
        call mpi_irecv(recvrr,lenrr,mpi_real,nebrr,ntagll,mpi_comm_world,irecvrr,ierr)
      endif
c send
      call mpi_isend(sendrr,lenrr,mpi_real,
     1                nebrr,ntagrr,mpi_comm_world,isendrr,ierr)
c recv
!      call mpi_irecv(recvrr,lenrr,mpi_real,
!     1                nebrr,ntagll,mpi_comm_world,irecvrr,ierr)

c ll
#ifdef CHECKSTATUS
      call mpi_wait(irecvll, status, ierr)
      write(6,"(a,i4,a,i8,i4,i4,i4,i4,i4)"),'Rank ',myrank,': Status from wait on irecvll ',status, ierr
#else
      call mpi_wait(irecvll, MPI_STATUS_IGNORE, ierr)
#endif
      if( nebll.ne.MPI_PROC_NULL ) then
#if defined PREFETCH
!        call mm_prefetch(a(1,1,:),1)
#endif
        mk=0
#ifdef TIMERS
        wstart = MPI_Wtime()
#endif
        do k=1,ntotal
#ifdef VERSION2D
          do j=1,1
#else
          do j=1,myjlen(mynum)
#endif
            do i=1,lb
               mk=mk+1
#ifdef CHECKRECV
               if( (recvll(mk) .ne. dble(nebll))       .and. 
     .             (recvll(mk) .ne. dble(nebll-ncol_)) .and.
     .             (recvll(mk) .ne. dble(nebll+ncol_))      ) then
          write(6,"(a,i4,a,i4,i4,i4,a,i4,i4,i4)"),'Rank ',myrank,' recvll .ne. nebll at ',i,j,k,' mk=',mk,int(recvll(mk)),nebll
                  stop
               endif
#endif
               a(i,j,k)=recvll(mk)
            enddo
          enddo
        enddo
#ifdef TIMERS
        wstop = MPI_Wtime()
        print *,myrank,': time unpacking recvll',(wstop-wstart)*1.e6,' us'
#endif
      endif
c rr
#ifdef CHECKSTATUS
      call mpi_wait(irecvrr, status, ierr)
      write(6,"(a,i4,a,i8,i4,i4,i4,i4,i4)"),'Rank ',myrank,': Status from wait on irecvrr ',status, ierr
#else
      call mpi_wait(irecvrr, MPI_STATUS_IGNORE, ierr)
#endif
      if( nebrr.ne.MPI_PROC_NULL ) then
#if defined PREFETCH
!        call mm_prefetch(a(myilen(mynum)-lb+1,1,:),1)
#endif
        mk=0
#ifdef TIMERS
        wstart = MPI_Wtime()
#endif
        do k=1,ntotal
#ifdef VERSION2D
          do j=1,1
#else
          do j=1,myjlen(mynum)
#endif
            do i=myilen(mynum)-lb+1,myilen(mynum)
               mk=mk+1
#ifdef CHECKRECV
               if( (recvrr(mk) .ne. dble(nebrr))       .and.
     .             (recvrr(mk) .ne. dble(nebrr-ncol_)) .and.
     .             (recvrr(mk) .ne. dble(nebrr+ncol_))      ) then
          write(6,"(a,i4,a,i4,i4,i4,a,i4,i4,i4)"),'Rank ',myrank,' recvrr .ne. nebrr at ',i,j,k,' mk=',mk,int(recvrr(mk)),nebrr
                  stop
               endif
#endif
               a(i,j,k)=recvrr(mk)
             enddo
           enddo
         enddo
#ifdef TIMERS
        wstop = MPI_Wtime()
        print *,myrank,': time unpacking recvrr',(wstop-wstart)*1.e6,' us'
#endif
      endif
c
c wait
      call mpi_wait(isendtt, MPI_STATUS_IGNORE, ierr)
      call mpi_wait(isendbb, MPI_STATUS_IGNORE, ierr)
      call mpi_wait(isendll, MPI_STATUS_IGNORE, ierr)
      call mpi_wait(isendrr, MPI_STATUS_IGNORE, ierr)
      deallocate(sendtt)
      deallocate(sendbb)
      deallocate(sendll)
      deallocate(sendrr)
      deallocate(recvtt)
      deallocate(recvbb)
      deallocate(recvll)
      deallocate(recvrr)

! DSK set halo corners to a signalling NaN
! leave this here in case anyone wants to figure out why physics is using the halo corners
! ----------------------------------------------------------------------------------------
!      do k=1,ntotal
!         a(1,1,k)=Z'7FFC000000000000'
!         a(2,1,k)=Z'7FFC000000000000'
!         a(1,2,k)=Z'7FFC000000000000'
!         a(2,2,k)=Z'7FFC000000000000'

!         a(1,myjlen(mynum)-lb+1,k)=Z'7FFC000000000000'
!         a(2,myjlen(mynum)-lb+1,k)=Z'7FFC000000000000'
!         a(1,myjlen(mynum)     ,k)=Z'7FFC000000000000'
!         a(2,myjlen(mynum)     ,k)=Z'7FFC000000000000'

!         a(myilen(mynum)-lb+1,1,k)=Z'7FFC000000000000'
!         a(myilen(mynum)     ,1,k)=Z'7FFC000000000000'
!         a(myilen(mynum)-lb+1,2,k)=Z'7FFC000000000000'
!         a(myilen(mynum)     ,2,k)=Z'7FFC000000000000'

!         a(myilen(mynum)-lb+1,myjlen(mynum)-lb+1,k)=Z'7FFC000000000000'
!         a(myilen(mynum)     ,myjlen(mynum)-lb+1,k)=Z'7FFC000000000000'
!         a(myilen(mynum)-lb+1,myjlen(mynum)     ,k)=Z'7FFC000000000000'
!         a(myilen(mynum)     ,myjlen(mynum)     ,k)=Z'7FFC000000000000'
!      enddo
c
#ifdef COUNT_TIME
      call timer(ite)
      time_mpe=time_mpe+(ite-its)/100.
#endif
#endif
c
      return
      end
