      subroutine rmp_updatehalo_DerType(a,nxp,myp,ntotal,lb)
#include <define.h>
c
c update the halo regions from neighbour PEs
c
#ifdef MPE
#include <rmp_mpif.h>
#include <rmp_rank.h>
#include <rmp_index.h>
c
      dimension a(nxp,myp,ntotal)
#ifdef CHECKSTATUS
      integer status(MPI_STATUS_SIZE)
#endif
c
#ifdef COUNT_TIME
      call timer(its)
#endif
c
c send and receive interactively with wait
c
      ntagtt=1
      ntagbb=2
      ntagll=3
      ntagrr=4
      nebtt=mynebtt(mynum)
      nebbb=mynebbb(mynum)
      nebll=mynebll(mynum)
      nebrr=mynebrr(mynum)

c -------------- top and bottom (partial) ----------
c tt
      if( nebtt.ne.-1 ) then
        lentt=1
        call mpi_irecv(a(1,1,1),lentt,NorthUnpack,nebtt,ntagbb,mpi_comm_world,irecvtt,ierr)
      else
        lentt=0
        nebtt=MPI_PROC_NULL
        call mpi_irecv(a(1,1,1),lentt,NorthUnpack,nebtt,ntagbb,mpi_comm_world,irecvtt,ierr)
      endif
c send
      call mpi_isend(a(1,1,1),lentt,NorthPack,nebtt,ntagtt,mpi_comm_world,isendtt,ierr)
!      if(ierr /= MPI_SUCCESS) print*,': Failure during mpi_isend1 ',ierr

c bb
      if( nebbb.ne.-1 ) then
        lenbb=1
        call mpi_irecv(a(1,1,1),lenbb,SouthUnpack,nebbb,ntagtt,mpi_comm_world,irecvbb,ierr)
      else
        lenbb=0
        nebbb=MPI_PROC_NULL
        call mpi_irecv(a(1,1,1),lenbb,SouthUnpack,nebbb,ntagtt,mpi_comm_world,irecvbb,ierr)
      endif
c send
      call mpi_isend(a(1,1,1),lenbb,SouthPack,nebbb,ntagbb,mpi_comm_world,isendbb,ierr)
!      if(ierr /= MPI_SUCCESS) print*,': Failure during mpi_isend2 ',ierr

! And now we wait for the recv to finish then unpack the buffer
! -------------------------------------------------------------
#ifdef CHECKSTATUS
      call mpi_wait(irecvtt, status, ierr)
      write(6,"(a,i4,a,i8,i4,i4,i4,i4,i4)"),'Rank ',myrank,': Status from wait on irecvtt ',status, ierr
      call mpi_wait(irecvbb, status, ierr)
      write(6,"(a,i4,a,i8,i4,i4,i4,i4,i4)"),'Rank ',myrank,': Status from wait on irecvbb ',status, ierr
#else
      call mpi_wait(irecvtt, MPI_STATUS_IGNORE, ierr)
      call mpi_wait(irecvbb, MPI_STATUS_IGNORE, ierr)
#endif
c
c ----------------- left and right (full) ----------------
c ll
      if( nebll.ne.-1 ) then
        lenll=1
        call mpi_irecv(a(1,1,1),lenll,WestUnpack,nebll,ntagrr,mpi_comm_world,irecvll,ierr)
      else
        lenll=0
        nebll=MPI_PROC_NULL
        call mpi_irecv(a(1,1,1),lenll,WestUnpack,nebll,ntagrr,mpi_comm_world,irecvll,ierr)
      endif
c send
      call mpi_isend(a(1,1,1),lenll,WestPack,nebll,ntagll,mpi_comm_world,isendll,ierr)
!      if(ierr /= MPI_SUCCESS) print*,': Failure during mpi_isend3 ',ierr
c rr
      if( nebrr.ne.-1 ) then
        lenrr=1
        call mpi_irecv(a(1,1,1),lenrr,EastUnpack,nebrr,ntagll,mpi_comm_world,irecvrr,ierr)
      else
        lenrr=0
        nebrr=MPI_PROC_NULL
        call mpi_irecv(a(1,1,1),lenrr,EastUnpack,nebrr,ntagll,mpi_comm_world,irecvrr,ierr)
      endif
c send
      call mpi_isend(a(1,1,1),lenrr,EastPack,nebrr,ntagrr,mpi_comm_world,isendrr,ierr)
!      if(ierr /= MPI_SUCCESS) print*,': Failure during mpi_isend4 ',ierr
#ifdef CHECKSTATUS
c ll
      call mpi_wait(irecvll, status, ierr)
      write(6,"(a,i4,a,i8,i4,i4,i4,i4,i4)"),'Rank ',myrank,': Status from wait on irecvll ',status, ierr
c rr
      call mpi_wait(irecvrr, status, ierr)
      write(6,"(a,i4,a,i8,i4,i4,i4,i4,i4)"),'Rank ',myrank,': Status from wait on irecvrr ',status, ierr
#else
      call mpi_wait(irecvll, MPI_STATUS_IGNORE, ierr)
      call mpi_wait(irecvrr, MPI_STATUS_IGNORE, ierr)
#endif
c
c wait
#ifdef CHECKSTATUS
      call mpi_wait(isendtt, status, ierr)
      write(6,"(a,i4,a,i8,i4,i4,i4,i4,i4)"),'Rank ',myrank,': Status from wait on isendtt ',status, ierr
      call mpi_wait(isendbb, status, ierr)
      write(6,"(a,i4,a,i8,i4,i4,i4,i4,i4)"),'Rank ',myrank,': Status from wait on isendbb ',status, ierr
      call mpi_wait(isendll, status, ierr)
      write(6,"(a,i4,a,i8,i4,i4,i4,i4,i4)"),'Rank ',myrank,': Status from wait on isendll ',status, ierr
      call mpi_wait(isendrr, status, ierr)
      write(6,"(a,i4,a,i8,i4,i4,i4,i4,i4)"),'Rank ',myrank,': Status from wait on isendrr ',status, ierr
#else
      call mpi_wait(isendtt, MPI_STATUS_IGNORE, ierr)
      call mpi_wait(isendbb, MPI_STATUS_IGNORE, ierr)
      call mpi_wait(isendll, MPI_STATUS_IGNORE, ierr)
      call mpi_wait(isendrr, MPI_STATUS_IGNORE, ierr)
#endif

! DSK set halo corners to a signalling NaN
! leave this here in case anyone wants to figure out why physics is using the halo corners
! ----------------------------------------------------------------------------------------
!      do k=1,ntotal
!         a(1,1,k)=Z'7FFC000000000000'
!         a(2,1,k)=Z'7FFC000000000000'
!         a(1,2,k)=Z'7FFC000000000000'
!         a(2,2,k)=Z'7FFC000000000000'
!         a(1,myjlen(mynum)-lb+1,k)=Z'7FFC000000000000'
!         a(2,myjlen(mynum)-lb+1,k)=Z'7FFC000000000000'
!         a(1,myjlen(mynum)     ,k)=Z'7FFC000000000000'
!         a(2,myjlen(mynum)     ,k)=Z'7FFC000000000000'
!         a(myilen(mynum)-lb+1,1,k)=Z'7FFC000000000000'
!         a(myilen(mynum)     ,1,k)=Z'7FFC000000000000'
!         a(myilen(mynum)-lb+1,2,k)=Z'7FFC000000000000'
!         a(myilen(mynum)     ,2,k)=Z'7FFC000000000000'
!         a(myilen(mynum)-lb+1,myjlen(mynum)-lb+1,k)=Z'7FFC000000000000'
!         a(myilen(mynum)     ,myjlen(mynum)-lb+1,k)=Z'7FFC000000000000'
!         a(myilen(mynum)-lb+1,myjlen(mynum)     ,k)=Z'7FFC000000000000'
!         a(myilen(mynum)     ,myjlen(mynum)     ,k)=Z'7FFC000000000000'
!      enddo
c
#ifdef COUNT_TIME
      call timer(ite)
      time_mpe=time_mpe+(ite-its)/100.
#endif
#endif
c
      return
      end
