#!/bin/csh
#PBS -l walltime=1:00:00
#PBS -l select=4:ncpus=16:model=ivy:mpiprocs=16 -l nobackupp8=0
#PBS -N GCE_halo
#PBS -q devel
#PBS -W group_list=cstaff
#PBS -j oe

cd /u/dkokron/Projects/HaloUpdate/rmp/ForMPICH
sort -u $PBS_NODEFILE

module purge
module load comp-intel/2013.5.192 mpi/mpich-3.1rc2/intel-13.1.3.192

set ncpus=64
set log=timings${ncpus}p_`echo $PBS_JOBID| cut -d. -f1`
touch $log

foreach i ( `seq 1 200` )
  mpirun -iface ib0 -bind-to core -ppn 16 -f $PBS_NODEFILE -np $ncpus test_halo_update.x >>& $log
  sleep 4
end

set mean=`cat $log | grep "updatehalo " | awk '{t+=$2;denom=denom+1;print t/denom}' | tail -1`
set  std=`cat $log | grep "updatehalo " | awk -v val=$mean '{t+=($2-val)^2;denom=denom+1;print t" "denom}' | tail -1 | awk '{print sqrt($1)/($2-1)}'`
echo $mean "+-" $std "us"

set mean2=`cat $log | grep updatehalo_DerType | awk '{t+=$2;denom=denom+1;print t/denom}' | tail -1`
set  std2=`cat $log | grep updatehalo_DerType | awk -v val=$mean2 '{t+=($2-val)^2;denom=denom+1;print t" "denom}' | tail -1 | awk '{print sqrt($1)/($2-1)}'`
echo $mean2 "+-" $std2 "us"

exit

